10 REM formspot -- moving and spotting formations of ships
11 REM note: ships stay spotted once spotted unless spot flag is turned off manually
15 CLS
20 DIM x(20): DIM y(20): DIM l(20): DIM m(20): DIM d(20): DIM s(20): DIM r(20): DIM z(20): DIM v(20): DIM dr(20)
25 FOR m = 1 TO 20
30 x(m) = 0: y(m) = 0: l(m) = 0: m(m) = 0: d(m) = 0: s(m) = 0: r(m) = 0: z(m) = 0: v(m) = 0: dr(m) = 0
35 NEXT m
45 REM x is x location, y is y location, l is formation length, m is spotting modifier, d is course, s is speed, r is radar range, z is ship size, v is whether formation was sighted, dr is course in radians
50 CLS : INPUT "Enter formation number to edit a formation (1-20), 0 to move to main options, 99 to stop program)"; tf
55 IF tf = 0 THEN GOTO 1000
60 IF tf = 99 THEN STOP
65 IF tf > 20 THEN GOTO 50
70 PRINT : PRINT "Formation is currently at x"; x(tf); "and y"; y(tf)
80 PRINT "Formation speed is currently"; s(tf); "on a course of"; d(tf)
90 PRINT "Formation length is"; l(tf); ".  Radar range is"; r(tf); "."
100 PRINT "Modifier is"; m(tf); ".  Ship size is"; z(tf); "."
105 IF v(tf) = 1 THEN PRINT "Formation is spotted."
110 PRINT : INPUT "Enter 1 to return to formation menu or 2 to adjust formation"; j4
120 IF j4 = 1 THEN GOTO 50
130 IF j4 < 2 OR j4 > 2 THEN GOTO 110
500 PRINT : INPUT "X coordinate of formation"; x(tf)
510 INPUT "Y coordinate of formation"; y(tf)
520 INPUT "Length of formation"; l(tf)
530 INPUT "Course of task force"; d(tf): dr(tf) = d(tf) * 3.14159 / 180
540 INPUT "Speed of formation"; s(tf)
550 INPUT "Sighting modifiers applicably to formation"; m(tf)
560 INPUT "Radar range"; r(tf)
570 INPUT "Ship size (1=DD, 2=CL/CA, 3=BB)"; z(tf)
575 INPUT "Formation spotted (enter 1) or unspotted (enter 0)"; v(rf)
580 INPUT "Review data and enter 1 to continue or 2 to begin turns"; jk
590 IF jk = 1 THEN CLS : GOTO 50
600 IF jk = 2 THEN CLS : GOTO 1000
610 GOTO 580
1000 CLS : PRINT "Enter formation number (1-20) to alter course, speed and sighting modifier": PRINT "Enter -1 to run movement": PRINT "Enter -2 to run spotting": PRINT "Enter -3 to return to formation adjustment": INPUT "Enter 99 to end program"; fr
1010 IF fr = -1 THEN GOTO 2000
1015 IF fr = -2 THEN GOTO 3000
1017 IF fr = -3 THEN GOTO 50
1020 IF fr = 99 THEN STOP
1030 IF fr > 20 OR fr < -2 THEN GOTO 1000
1050 PRINT : PRINT "Formation coordinates are x "; x(fr); "and y "; y(fr)
1055 PRINT "Formation sighting modifier is"; m(fr)
1060 PRINT "Formation course is"; d(fr); "and speed is"; s(fr)
1070 PRINT "Formatiom sighting modifier is "; m(fr)
1100 PRINT : INPUT "Enter 1 to change course and speed or 2 to continue"; jl
1110 IF jl = 1 THEN GOTO 1200
1120 IF jl = 2 THEN GOTO 1000
1130 GOTO 1100
1200 PRINT : INPUT "Enter new course for formation "; d(fr)
1205 dr(fr) = d(fr) * (3.14159 / 180)
1210 INPUT "Enter new speed for formation"; s(fr)
1215 INPUT "Enter new sighting modifier for formation"; m(fr)
1220 INPUT "Enter 1 to confirm new course and speed or 2 to reenter"; j1
1230 IF j1 = 1 THEN CLS : GOTO 1000
1240 IF j1 = 2 THEN GOTO 1200
1250 GOTO 1220
2000 FOR n = 1 TO 20
2010 x(n) = (SIN(dr(n)) * s(n)) + x(n)
2020 y(n) = (COS(dr(n)) * s(n)) + y(n)
2025 x(n) = (INT(x(n) * 10)) / 10
2030 y(n) = (INT(y(n) * 10)) / 10
2035 NEXT n
2040 tn = tn + 1
2050 PRINT : PRINT "Movement complete for turn"; tn: INPUT "Press enter to continue"; j5
2060 GOTO 1000
3000 CLS : PRINT : INPUT "Enter 1 for Force A (Form 1-10) Sightings and 2 for Force B (Form 11-20) Sightings (3 to return to menu)"; j2
3010 IF j2 = 1 THEN GOTO 3300
3020 IF j2 = 2 THEN GOTO 4300
3025 IF j2 = 3 THEN GOTO 1000
3030 GOTO 3000
3300 PRINT : sd = 0: INPUT "Enter Force A basic spotting distance"; sd
3305 REM for n=11 to 20:v(n)=0:next n
3310 FOR n = 1 TO 10
3315 IF x(n) = 0 AND y(n) = 0 THEN GOTO 3360
3320 FOR m = 11 TO 20
3325 IF x(m) = 0 AND y(m) = 0 THEN GOTO 3350
3330 IF v(m) = 1 THEN GOTO 3350
3340 IF ((x(n) - x(m)) ^ 2 + (y(n) - y(m)) ^ 2) ^ .5 <= sd + m(m) THEN v(m) = 1
3350 NEXT m
3360 NEXT n
3400 FOR n = 1 TO 10
3405 IF x(n) = 0 AND y(n) = 0 THEN GOTO 3530
3410 IF d(n) <= 180 THEN ld = d(n) + 180
3420 IF d(n) > 180 THEN ld = d(n) - 180
3430 ld = ld * 3.14159 / 180
3440 lx = SIN(ld) * l(n): ly = COS(ld) * l(n)
3450 FOR m = 11 TO 20
3445 IF x(m) = 0 AND y(m) = 0 THEN GOTO 3520
3455 IF v(m) = 1 THEN GOTO 3520
3460 IF d(m) <= 180 THEN lm = d(m) + 180
3470 IF d(m) > 180 THEN lm = d(m) - 180
3480 tx = SIN(lm) * l(m): ty = COS(lm) * l(m)
3490 IF ((lx - tx) ^ 2 + (ly - ty) ^ 2) ^ .5 <= sd + m(m) THEN v(m) = 1
3500 IF ((lx - x(m)) ^ 2 + (ly - y(m)) ^ 2) ^ .5 <= sd + m(m) THEN v(m) = 1
3510 IF ((x(n) - tx) ^ 2 + (y(n) - ty) ^ 2) ^ .5 <= sd + m(m) THEN v(m) = 1
3520 NEXT m
3530 NEXT n
3600 REM radar search
3610 FOR n = 1 TO 10
3615 IF x(n) = 0 AND y(n) = 0 THEN GOTO 3680
3620 IF r(n) < 5 THEN GOTO 3680
3630 FOR m = 11 TO 20
3633 IF v(m) = 1 THEN GOTO 3670
3636 IF x(m) = 1 AND y(m) = 1 THEN GOTO 3670
3640 IF z(m) = 2 THEN rr = r(n) + 5
3650 IF z(m) = 3 THEN rr = r(n) + 10
3660 IF ((x(n) - x(m)) ^ 2 + (y(n) - y(m)) ^ 2) ^ .5 = rr THEN v(m) = 1
3670 NEXT m
3680 NEXT n
3800 PRINT
3805 FOR n = 11 TO 20
3810 IF v(n) = 1 THEN PRINT "Formation"; n; "at x "; x(n); " and y"; y(n); ",course "; d(n)
3820 NEXT n
3830 PRINT : INPUT "Enter any number to clear this screen and return to Formation search screen"; j3
3840 GOTO 3000
4300 sd = 0: INPUT "Enter Force B basic spotting distance"; sd
4305 REM for n=1 to 10:v(n)=0: next n
4310 FOR n = 11 TO 20
4320 FOR m = 1 TO 10
4325 IF x(m) = 0 AND y(m) = 0 THEN GOTO 4350
4330 IF v(m) = 1 THEN GOTO 4350
4340 IF ((x(n) - x(m)) ^ 2 + (y(n) - y(m)) ^ 2) ^ .5 <= sd + m(m) THEN v(m) = 1
4350 NEXT m
4360 NEXT n
4400 FOR n = 11 TO 20
4405 IF x(n) = 0 AND y(n) = 0 THEN GOTO 4530
4410 IF d(n) <= 180 THEN ld = d(n) + 180
4420 IF d(n) > 180 THEN ld = d(n) - 180
4430 ld = ld * 3.14159 / 180
4440 lx = SIN(ld) * l(n): ly = COS(ld) * l(n)
4450 FOR m = 1 TO 10
4452 IF x(m) = 0 AND y(m) = 0 THEN GOTO 4520
4455 IF v(m) = 1 THEN GOTO 4520
4460 IF d(m) <= 180 THEN lm = d(m) + 180
4470 IF d(m) > 180 THEN lm = d(m) - 180
4480 tx = SIN(lm) * l(m): ty = COS(lm) * l(m)
4490 IF ((lx - tx) ^ 2 + (ly - ty) ^ 2) ^ .5 <= sd + m(m) THEN v(m) = 1
4500 IF ((lx - x(m)) ^ 2 + (ly - y(m)) ^ 2) ^ .5 <= sd + m(m) THEN v(m) = 1
4510 IF ((x(n) - tx) ^ 2 + (y(n) - ty) ^ 2) ^ .5 <= sd + m(m) THEN v(m) = 1
4520 NEXT m
4530 NEXT n
4600 REM radar search
4610 FOR n = 11 TO 20
4620 IF r(n) < 5 THEN GOTO 4680
4625 IF x(n) = 0 AND y(n) = 0 THEN GOTO 4680
4630 FOR m = 1 TO 10
4633 IF v(m) = 1 THEN GOTO 4670
4636 IF x(m) = 0 AND y(m) = 0 THEN GOTO 4670
4640 IF z(m) = 2 THEN rr = r(n) + 5
4650 IF z(m) = 3 THEN rr = r(n) + 10
4660 IF ((x(n) - x(m)) ^ 2 + (y(n) - y(m)) ^ 2) ^ .5 = rr THEN v(m) = 1
4670 NEXT m
4680 NEXT n
4800 PRINT
4805 FOR n = 1 TO 10
4810 IF v(n) = 1 THEN PRINT "Formation"; n; "at x"; x(n); " and y"; y(n); ",course "; d(n)
4820 NEXT n
4830 PRINT : INPUT "Enter any number to clear this screen and return to formation search screen"; j3
4840 GOTO 3000

